/*
    ES Knot
    Copyright 2005 - 2008 Martin Storsjo

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

    Martin Storsjo
    martin@martin.st
*/

#ifndef __KNOTINTERFACE_H
#define __KNOTINTERFACE_H

class KnotInterface {
public:
	virtual ~KnotInterface() {}
	virtual void draw(unsigned int msec) = 0;
	virtual void reinit() = 0;
	virtual void clearContext() = 0;
	virtual void setSize(int w, int h) = 0;
	virtual bool getMatrixSupported() = 0;

	enum TexMode { UNTEXTURED = 0, PLAINTEX, TEXSPEC, CELSHADED, MAX_TEXMODE };
	virtual void setTexMode(TexMode mode) = 0;
	virtual void setUpdateVertices(bool update) = 0;
	virtual void setMotionBlur(bool blur) = 0;
	virtual void setRadialBlur(bool blur) = 0;
	virtual void setRadialGlow(bool glow) = 0;

	virtual void startMorph() = 0;

	virtual void enableRotate(bool rotate) = 0;
	virtual void enableGravity(bool gravity) = 0;
	virtual void rotate(int x, int y) = 0;
	
	virtual void setGravity(float x, float y, float z) = 0;

protected:
	KnotInterface() {}
};

KnotInterface* createKnot1(int w, int h);
#ifdef USE_OES_2
KnotInterface* createKnot2(int w, int h);
#endif

#endif
